# reset path
PATH=$HOME/bin:/opt/osxws/bin:/bin:/usr/bin:/opt/X11/bin
PATH=$PATH:/opt/osxws/sbin:/usr/sbin:/sbin

export ROOTSYS=/opt/root/5.34.36
shell=$(basename $(echo $0 | sed -e 's;^-*\(.*\);\1;'))
if [ $(echo $shell | grep -vc 'setup.sh') = 0 ]; then
   shell=zsh
fi
if [ x$shell = xzsh ]; then
   opt="-q"
   pushd $opt $ROOTSYS
   source $ROOTSYS/bin/thisroot.sh
   popd $opt
else
   opt=""
   source $ROOTSYS/bin/thisroot.sh
fi
if [ "x$(uname -s)" = "xDarwin" ]; then
  LD_LIBRARY_PATH=$DYLD_LIBRARY_PATH
fi
export LCSOFTDIR=/Users/proj/soft/lcsoft
export G4INSTALL=/opt/g4/9.6.p02
export LCIO=/opt/lcio/v02-13-01
export CERN_ROOT=/opt/cern/2006
export PYTHIA_ROOT=/opt/pythia/v6.428
export STDHEPDIR=/opt/stdhep/stdhep-5-06-01
#export WHIZDIR=/opt/whizard/whizard-2.2.8
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$PYTHIA_ROOT/lib

#--
#  Common software Environment 
#--
export EXTSOFTDIR=/opt

export CLHEP_BASE_DIR=/opt/clhep/2.2.0.1
export CLHEP=$CLHEP_BASE_DIR
export CLHEP_INCLUDE_DIR=$CLHEP/include
export CLHEP_LIB_DIR=$CLHEP/lib

export JAVA_HOME=/Library/Java/Home
export JDK_HOME=$JAVA_HOME


PATH=$PATH:$LCIO/bin:$LCIO/tools:$CLHEP/bin
PATH=$PATH:$CLHEP/bin
PATH=$PATH:$JAVA_HOME/bin
export PATH

#--
#  Geant4 environmental variables
#--
if [ x$shell = xzsh ]; then
   pushd $opt $G4INSTALL/bin
   source $G4INSTALL/bin/geant4.sh
   popd $opt
else
   source $G4INSTALL/bin/geant4.sh
fi

export G4SYSTEM=Darwin-g++
export G4LIB=$G4INSTALL/lib/Geant4-9.6.2
export G4INCLUDE=$G4INSTALL/include/Geant4

#--
#  LC software Environment 
#--
export LCBASEDIR=$LCSOFTDIR/lcbase/pro

export LEDAROOT=$LCSOFTDIR/leda/pro

export LCLIBROOT=$LCSOFTDIR/lclib/pro

export JSFROOT=$LCSOFTDIR/jsf/pro

export KFLIBROOT=$LCSOFTDIR/physsim/pro

export IMAKEINCLUDE="-I$LCBASEDIR -I$JSFROOT -I$LCLIBROOT -I$KFLIBROOT"
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$LEDAROOT/lib:$JSFROOT/lib

export JUPITERROOT=$LCSOFTDIR/jupiter/pro

export URANUSROOT=$LCSOFTDIR/uranus/pro
export SATELLITESROOT=$LCSOFTDIR/satellites/pro

export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$URANUSROOT/lib:$SATELLITESROOT/lib
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$KFLIBROOT/lib

PATH=$PATH:$LCBASEDIR/bin
PATH=$PATH:$LCLIBROOT/bin:$CERN_ROOT/bin
PATH=$PATH:$JSFROOT/bin
PATH=$PATH:$JUPITERROOT/scripts

export DYLD_LIBRARY_PATH=$LD_LIBRARY_PATH
export PATH

export SOSYMLINK=true

