#ifndef JSFParticleData_H
#define JSFParticleData_H
#include <iostream>
#include <cstdlib>
//
// Interface to get particle information
//
// Implementation of this class depends on Pythia version

class JSFParticleData
{
 public:
   virtual ~JSFParticleData() {}

   virtual float GetCharge(int id)
   {
      return GetInstancePtr()->GetCharge(id);
   }

   virtual float GetCTau(int id)
   {
      return GetInstancePtr()->GetCTau(id);
   }
   static JSFParticleData *GetInstancePtr()
   {
      if (fgInstancePtr) return fgInstancePtr;
      else {
         std::cerr << "Error: JSFParticleData does not exist"   << std::endl
                   << "  Create a real JSFParticleData!"        << std::endl;
         std::abort();
      }
   }

   static void SetInstancePtr(JSFParticleData *ptr) {
      if (fgInstancePtr) delete fgInstancePtr;
      fgInstancePtr = ptr;
   }

 private:
   static JSFParticleData *fgInstancePtr;
};
#endif
