#ifndef JSFVQUICKSIM_H
#define JSFVQUICKSIM_H

//////////////////////////////////////////////////////////////////////////
//
// JSFVQuickSim
//
// A template for JSFVQuickSim
//
//////////////////////////////////////////////////////////////////////////

#include "JSFModule.h"

class JSFVQuickSim;
class JSFGeneratorBuf;

// ******* JSFVQuickSimBuf class ********************************
class JSFVQuickSimBuf : public JSFEventBuf {
public:
   JSFVQuickSimBuf(const char *name,
		   const char *title="JSF QuickSim event class",
		   JSFVQuickSim *sim=NULL);
   JSFVQuickSimBuf() {}
   virtual      ~JSFVQuickSimBuf() {}

   void SetGeneratorPointers(JSFGeneratorBuf *ingen=NULL) ; // Set pointers among Hits/Track classes.
   void Append(JSFVQuickSimBuf *src, Int_t numgp, JSFGeneratorBuf *gsrc);

   ClassDef(JSFVQuickSimBuf, 1) // QuickSim event buffer class.
};
 
// ******* JSFVQuickSim class *********************************
class JSFVQuickSim : public JSFModule {
public:
   JSFVQuickSim(const Char_t *name="JSFVQuickSim", 
	        const Char_t *title="JSFVQuickSim",
	        const Char_t *opt="");
   virtual      ~JSFVQuickSim() {}

   static JSFVQuickSim *GetInstancePtr();
   static void SetInstancePtr(JSFVQuickSim *p);

private:
   static JSFVQuickSim *fgInstancePtr; //!

   ClassDef(JSFVQuickSim,1)  // Quick Simulator
};

#endif

