#ifndef __MYPFOANALYSIS__
#define __MYPFOANALYSIS__
//*************************************************************************
//* -----------
//* MyPFOAnalysis
//* -----------
//* (Description)
//* 	Classes to analyze PFO data.
//* (Update Record)
//*	2006/12/20  K.Fujii	Original version.
//*************************************************************************

#include "TH1.h"
#include "TH2.h"
#include "TCanvas.h"

#include "S4PFObject.h"

class S4JetSet;

class MyPFOAnalysis : public JSFModule {
public:
   MyPFOAnalysis(const Char_t *name  = "MyPFOAnalysis",
		 const Char_t *title = "PFO Analysis");
   virtual ~MyPFOAnalysis();

   Bool_t Initialize();
   Bool_t Process(Int_t ev);


private:
   virtual void        MonitorPFOs(Int_t ev);
   virtual TObjArray & GetPrimaryBPs();
   virtual S4JetSet  * GetJetSet(Int_t njets = 2);

private:
   TObjArray fPrimaryBPs;
   
   ClassDef(MyPFOAnalysis, 1) // PFO Analysis class
};

#endif

