void PlotPFO(const Char_t *fname = "jsf.pfoanl.uds91.v0.std2.10k.root")
//void PlotPFO(const Char_t *fname = "jsf.pfoanl.zz700.v0.std.10k.root")
//void PlotPFO(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.std.10k.root")
//void PlotPFO(const Char_t *fname = "results/jsf.pfoanl.zz700.v0.std.10k.root")
//void PlotPFO(const Char_t *fname = "results/jsf.pfoanl.zz500.v0.std.10k.root")
//void PlotPFO(const Char_t *fname = "results/jsf.pfoanl.zz400.v0.std.10k.root")
//void PlotPFO(const Char_t *fname = "results/jsf.pfoanl.zz300.v0.std.10k.root")
//void PlotPFO(const Char_t *fname = "results/jsf.pfoanl.zz200.v0.std.10k.root")
{
  // ------------------------------------------------------------
  //  Open shared libraries
  // ------------------------------------------------------------
  gSystem->Load("libJSF.so");
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libAnlib.so");

  // ------------------------------------------------------------
  //  Open event file and apply cuts
  // ------------------------------------------------------------
  TFile *filep = TFile::Open(fname);
  TNtupleD *tuppfop = (TNtupleD *)gROOT->FindObject("hpfo");

  //tuppfop->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8&&mass>70&&mass<110","goff");
  //tuppfop->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8","goff");
#if 1
  tuppfop->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8","goff");
#else
  tuppfop->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.95&&abs(cosj2)<0.95","goff");
#endif
  TEventList *elistp = (TEventList *)gROOT->FindObject("elist");

  const Double_t kNsig = 2.;	// fit range for gaussian fit in units of sigma

  // ------------------------------------------------------------
  //  Define histograms
  // ------------------------------------------------------------
#if 0
  Double_t dEmin = -15.;
  Double_t dEmax = +15.;
  Double_t Emin  =   0.;
  //Double_t Emax  = 500.;
  Double_t Emax  = 200.;
  //Double_t Emax  = 350.;
#else
  Double_t dEmin = -15.;
  Double_t dEmax = +15.;
  Double_t Enom  = 90.;
  Double_t Emin  = Enom - 20.;
  Double_t Emax  = Enom + 20.;
#endif
  TH1D *hDetkbp = new TH1D("hDetkbp","",120,dEmin,dEmax);
  TH1D *hDeembp = new TH1D("hDeembp","",120,dEmin,dEmax);
  TH1D *hDehdbp = new TH1D("hDehdbp","",120,dEmin,dEmax);
  TH1D *hDejj   = new TH1D("hDejj"  ,"",120,dEmin,dEmax);
  TH1D *hEjj    = new TH1D("hEjj"   ,"", 80, Emin, Emax);
  TH1D *hMass   = new TH1D("hMass"  ,"", 80, Emin, Emax);
  TH1D *hMjj    = new TH1D("hMjj"   ,"", 80, Emin, Emax);
  TH1D *hEisr   = new TH1D("hEisr"  ,"",200,   0.,  50.);
  TH1D *hNpfo   = new TH1D("hNpfo"  ,"",100,   0., 200.);
  TH1D *hPID    = new TH1D("hPID"   ,"",5000, -2500., 2500.);
  TH1D *hPPID   = new TH1D("hPPID"  ,"", 100,   -50.,   50.);

  // ------------------------------------------------------------
  //  Loop over selected events and fill up histograms
  // ------------------------------------------------------------
  Int_t npfo = elistp->GetN();
  cerr << "Npfo = " << npfo << endl;
  Double_t evs   = -1;
  Double_t Eisr  = 0;
  Double_t Npfo  = 0;
  ANL4DVector qtot;

  Double_t Etk   = 0;
  Double_t Eem   = 0;
  Double_t Ehd   = 0;
  Double_t Etkbp = 0;
  Double_t Eembp = 0;
  Double_t Ehdbp = 0;

  for (Int_t i=0; i<npfo; i++) {
    Int_t iah = elistp->GetEntry(i);	// get undetected particle number

    Double_t ev, npj1, npj2, cosj1, cosj2, evis, mass;
    Double_t ch, pid, gppid, ppid, e, px, py, pz, ebp, etk;

    tuppfop->SetBranchAddress("ev",&ev);
    tuppfop->SetBranchAddress("npj1",&npj1);
    tuppfop->SetBranchAddress("npj2",&npj2);
    tuppfop->SetBranchAddress("cosj1",&cosj1);
    tuppfop->SetBranchAddress("cosj2",&cosj2);
    tuppfop->SetBranchAddress("evis",&evis);
    tuppfop->SetBranchAddress("mass",&mass);
    tuppfop->SetBranchAddress("ch",&ch);
    tuppfop->SetBranchAddress("pid",&pid);
#if 1
    tuppfop->SetBranchAddress("gppid",&gppid);
    tuppfop->SetBranchAddress("ppid",&ppid);
#else
    tuppfop->SetBranchAddress("ppid",&gppid);
    ppid = 0;
#endif
    tuppfop->SetBranchAddress("epfo",&e);
    tuppfop->SetBranchAddress("ebp",&ebp);
    tuppfop->SetBranchAddress("etk",&etk);
    tuppfop->SetBranchAddress("pxpfo",&px);
    tuppfop->SetBranchAddress("pypfo",&py);
    tuppfop->SetBranchAddress("pzpfo",&pz);

    tuppfop->GetEntry(iah);	// get this event

#if 0
    hPID ->Fill(pid ,1.);
    hPPID->Fill(gppid,1.);
#endif
    Double_t apid   = TMath::Abs(pid);
    Double_t agppid = TMath::Abs(gppid);
    Double_t appid  = TMath::Abs(ppid);

    if (evs != -1 && ev != evs) {
      hEjj   ->Fill(qtot.E(),1.);
      hMjj   ->Fill(qtot.Mag(),1.);
      hNpfo  ->Fill(Npfo,1.);
      hEisr  ->Fill(Eisr,1.);
      hMass  ->Fill(mass,1.);
      hDetkbp->Fill(Etk-Etkbp);
      hDeembp->Fill(Eem-Eembp);
      hDehdbp->Fill(Ehd-Ehdbp);
      hDejj  ->Fill(qtot.E()-Etkbp-Eembp-Ehdbp);
      Eisr  = 0;
      Etk   = 0;
      Eem   = 0;
      Ehd   = 0;
      Etkbp = 0;
      Eembp = 0;
      Ehdbp = 0;
      qtot.SetXYZT(0.,0.,0.,0.);
      Npfo  = 0;
    }
#if 0
    if (TMath::Abs(agppid-25)<0.1) {
#else
    if (TMath::Abs(agppid-23)<0.1) {
#endif
#if 1
      hPID ->Fill(pid ,1.);
      hPPID->Fill(gppid,1.);
#endif
      if (etk > 0.) { 
      // charged PFOs
#if 1
        const Double_t kMproton = 0.93827203;
        const Double_t kMpi     = 0.13957018;
#if 1
	if (TMath::Abs(pid-2212)<0.1 && TMath::Abs(pid-ppid)>0.1) { // 2ndary protons
          e   -= kMproton;
          ebp -= kMproton;
#else
	if (TMath::Abs(pid-2212)<0.1) { // assign pion mass to all protons
          e   = TMath::Sqrt(px*px+py*py+pz*pz+kMpi*kMpi);
          ebp = TMath::Sqrt((ebp-kMproton)*(ebp+kMproton)+kMpi*kMpi);
#endif
	}
#endif
        Etk   += e;
	Etkbp += ebp;
      } else if (TMath::Abs(apid-22)<0.1 || TMath::Abs(apid-11)<0.1) {
      // EM PFOs
        Eem   += e;
	Eembp += ebp;
      } else {
      // HD PFOs
#if 1
        const Double_t kFcorr = 1.065;
#else
        const Double_t kFcorr = 1.0;
#endif
	e *= kFcorr;
        Ehd   += e;
	Ehdbp += ebp;
	px *= kFcorr;
	py *= kFcorr;
	pz *= kFcorr;
      }
      ANL4DVector qpfo(e,px,py,pz);
      qtot += qpfo;
      Npfo++;
    } else if (TMath::Abs(agppid-22)<0.1) {
      Eisr  += e;
    }
    evs  = ev;
  }
  hEjj ->Fill(qtot.E(),1.);
  hMjj ->Fill(qtot.Mag(),1.);
  hNpfo->Fill(Npfo,1.);
  hEisr->Fill(Eisr,1.);
  hMass->Fill(mass,1.);
  hDetkbp->Fill(Etk-Etkbp);
  hDeembp->Fill(Eem-Eembp);
  hDehdbp->Fill(Ehd-Ehdbp);
  hDejj  ->Fill(qtot.E()-Etkbp-Eembp-Ehdbp);

  // ------------------------------------------------------------
  //  Draw histograms
  // ------------------------------------------------------------
  gStyle->SetOptFit(1);
  gStyle->SetOptStat(111111);

  TCanvas *c1p = new TCanvas("c1","",20,20,1220,820);
  TCanvas &c1  = *c1p;
  c1.Divide(3,2);
  Int_t id = 0;

  TPad *cpadp;
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDetkbp->Draw();
  ANLGaussFitter gfit(hDetkbp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDetkbp->SetFillColor(42);
  hDetkbp->SetFillStyle(1000);
  hDetkbp->GetXaxis()->SetTitle("#Delta E_{tk} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDeembp->Draw();
  ANLGaussFitter gfit(hDeembp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDeembp->SetFillColor(50);
  hDeembp->SetFillStyle(3001);
  hDeembp->GetXaxis()->SetTitle("#Delta E_{em} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDehdbp->Draw();
  ANLGaussFitter gfit(hDehdbp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDehdbp->SetFillColor(9);
  hDehdbp->SetFillStyle(3002);
  hDehdbp->GetXaxis()->SetTitle("#Delta E_{hd} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDejj->Draw();
  ANLGaussFitter gfit(hDejj,kNsig);
  gfit.GetFunction()->Draw("same");
  hDejj->SetFillColor(50);
  hDejj->SetFillStyle(1000);
  hDejj->GetXaxis()->SetTitle("#Delta E_{vis} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hMass->Draw();
  ANLGaussFitter gfit(hMass,kNsig);
  gfit.GetFunction()->Draw("same");
  hMass->SetFillColor(50);
  hMass->SetFillStyle(1000);
  hMass->GetXaxis()->SetTitle("M_{vis} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hMjj->Draw();
  ANLGaussFitter gfit(hMjj,kNsig);
  gfit.GetFunction()->Draw("same");
  hMjj->SetFillColor(50);
  hMjj->SetFillStyle(1000);
  hMjj->GetXaxis()->SetTitle("M_{jj} [GeV]");

#if 0
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEjj->Draw();
  ANLGaussFitter gfit(hEjj,kNsig);
  gfit.GetFunction()->Draw("same");
  hEjj->SetFillColor(9);
  hEjj->SetFillStyle(3002);
  hEjj->GetXaxis()->SetTitle("E_{jj} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hNpfo->Draw();
  hNpfo->SetFillColor(50);
  hNpfo->SetFillStyle(1000);
  hNpfo->GetXaxis()->SetTitle("N_{pfo}");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hPID->Draw();
  hPID->SetFillColor(50);
  hPID->SetFillStyle(1000);
  hPID->GetXaxis()->SetTitle("PID");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hPPID->Draw();
  hPPID->SetFillColor(50);
  hPPID->SetFillStyle(1000);
  hPPID->GetXaxis()->SetTitle("PPID");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEisr->Draw();
  hEisr->SetFillColor(50);
  hEisr->SetFillStyle(1000);
  hEisr->GetXaxis()->SetTitle("E_{ISR} [GeV]");
#endif

  c1.cd();
}
