//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds500.v0.tkemhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds500.v0.emhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds500.v0.emexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds500.v0.std.10k.root")
//
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds350.v0.tkemhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds350.v0.emhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds350.v0.emexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds350.v0.std.10k.root")
//
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds200.v0.tkemhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds200.v0.emhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds200.v0.emexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds200.v0.std.10k.root")
//
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.std.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.std.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds500.std.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds500.v0.std.10k.root")
//
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.nokink.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.kinkdau.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.kinkmom.10k.root")
void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.std.10k.root")
///void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.tkemhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.emhdexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.emexact.10k.root")
//void PlotQQ(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.hdexact.10k.root")
{
  // ------------------------------------------------------------
  //  Open shared libraries
  // ------------------------------------------------------------
  gSystem->Load("libJSF.so");
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libAnlib.so");

  // ------------------------------------------------------------
  //  Open event file and apply cuts
  // ------------------------------------------------------------
  TFile *filep = TFile::Open(fname);
  TNtupleD *tupep = (TNtupleD *)gROOT->FindObject("hevt");

  TString sfname(fname);
  Int_t ind1 = sfname.Index("uds") + 3;
  Int_t len  = TString(sfname(ind1,sfname.Length()).Data()).Index(".");
  Double_t ecm = TString(sfname(ind1,len).Data()).Atof();
  cerr << "Ecm = " << ecm << endl;

  Double_t Enom  = ecm;
  //Double_t Enom  = 90.;
  //Double_t Enom  = 200.;
  //Double_t Enom  = 350.;
  //Double_t Enom  = 500.;
  // Cuts
  Double_t xNpj  = 5.0;
  //Double_t xNpj  = 10.0;
  Double_t xCosj = 0.8;
#if 0
  // Standard cuts
  //tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8&&mass>70&&mass<110","goff");
  tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8","goff");
#else
  // No cut
  //tupep->Draw(">>elist","npj1>=0&&npj2>=0&&abs(cosj1)<1.&&abs(cosj2)<1.&&mass>70&&mass<110","goff");
  tupep->Draw(">>elist","npj1>=0&&npj2>=0&&abs(cosj1)<=1.&&abs(cosj2)<=1.","goff");
#endif
  TEventList *elistp = (TEventList *)gROOT->FindObject("elist");

  const Double_t kNsig = 2.;	// fit range for gaussian fit in units of sigma

  // ------------------------------------------------------------
  //  Define histograms
  // ------------------------------------------------------------
  TH1D *hEvisp    = new TH1D("hEvis"   , "", 80, Enom-20.,Enom+20.);
  TH2D *hPtPlp    = new TH2D("hPtPl"   , "", 40,  0., 20.,
                                             80,-20., 20.);
  TH1D *hNpjp     = new TH1D("hNpJ"    , "", 70,  0., 70.);
  TH1D *hCosjp    = new TH1D("hCosJ"   , "",100, -1.,  1.);
  TH1D *hEtotp    = new TH1D("hEtot"   , "", 80, Enom-20.,Enom+20.);
  TH1D *hMassp    = new TH1D("hMass"   , "", 80, Enom-20.,Enom+20.);
  TH1D *hMjjcp    = new TH1D("hMjj"    , "", 80, Enom-20.,Enom+20.);
  TH1D *hMjjcahp  = new TH1D("hMjjah"  , "", 80, Enom-20.,Enom+20.);

  // ------------------------------------------------------------
  //  Loop over selected events and fill up histograms
  // ------------------------------------------------------------
#if 0
  Int_t nevt = elistp->GetN();
  cerr << "Nevt = " << nevt << endl;

  for (Int_t i=0; i<nevt; i++) {
    Int_t ievt = elistp->GetEntry(i);	// get event number
#else
  ifstream fevlist("fevlist");
  Int_t nevt;
  fevlist >> nevt;
  cerr << "Nevt = " << nevt << endl;
  //Long64_t *evlist = new Long64_t[nevt];
  Int_t *evlist = new Int_t[nevt];
  for (Int_t i=0; i<nevt; i++) {
    fevlist >> evlist[i];
  }

  for (Int_t i=0; i<nevt; i++) {
    Int_t ievt = evlist[i];
#endif

    Double_t npj1, npj2, cosj1, cosj2, evis, pt, pl, mass;
    Double_t etk, eem, ehd, etkpbp, eempbp, ehdpbp, eah, pxah, pyah, pzah;
    Double_t etot, pxtot, pytot, pztot, ehdc, pxhd, pyhd, pzhd;
    Double_t edbltk, pxdbltk, pydbltk, pzdbltk,
             edblem, pxdblem, pydblem, pzdblem,
             edblhd, pxdblhd, pydblhd, pzdblhd;
    Double_t edbltkab, pxdbltkab, pydbltkab, pzdbltkab;
    Double_t edbltkmpc, pxdbltkmpc, pydbltkmpc, pzdbltkmpc;
    Double_t etkmpc, pxtkmpc, pytkmpc, pztkmpc;
    Double_t pxem, pyem, pzem;

    tupep->SetBranchAddress("npj1",&npj1);
    tupep->SetBranchAddress("npj2",&npj2);
    tupep->SetBranchAddress("cosj1",&cosj1);
    tupep->SetBranchAddress("cosj2",&cosj2);
    tupep->SetBranchAddress("evis",&evis);
    tupep->SetBranchAddress("pt",&pt);
    tupep->SetBranchAddress("pl",&pl);
    tupep->SetBranchAddress("mass",&mass);
    tupep->SetBranchAddress("etk",&etk);
    tupep->SetBranchAddress("eem",&eem);
    tupep->SetBranchAddress("ehd",&ehd);
    tupep->SetBranchAddress("etkpbp",&etkpbp);
    tupep->SetBranchAddress("eempbp",&eempbp);
    tupep->SetBranchAddress("ehdpbp",&ehdpbp);
    tupep->SetBranchAddress("eah",&eah);
    tupep->SetBranchAddress("pxah",&pxah);
    tupep->SetBranchAddress("pyah",&pyah);
    tupep->SetBranchAddress("pzah",&pzhd);
    tupep->SetBranchAddress("pxem",&pxem);
    tupep->SetBranchAddress("pyem",&pyem);
    tupep->SetBranchAddress("pzem",&pzem);
    tupep->SetBranchAddress("pxhd",&pxhd);
    tupep->SetBranchAddress("pyhd",&pyhd);
    tupep->SetBranchAddress("pzhd",&pzhd);
    tupep->SetBranchAddress("px",&pxtot);
    tupep->SetBranchAddress("py",&pytot);
    tupep->SetBranchAddress("pz",&pztot);
    tupep->SetBranchAddress("edbltk",&edbltk);
    tupep->SetBranchAddress("pxdbltk",&pxdbltk);
    tupep->SetBranchAddress("pydbltk",&pydbltk);
    tupep->SetBranchAddress("pzdbltk",&pzdbltk);
    tupep->SetBranchAddress("edblem",&edblem);
    tupep->SetBranchAddress("pxdblem",&pxdblem);
    tupep->SetBranchAddress("pydblem",&pydblem);
    tupep->SetBranchAddress("pzdblem",&pzdblem);
    tupep->SetBranchAddress("edblhd",&edblhd);
    tupep->SetBranchAddress("pxdblhd",&pxdblhd);
    tupep->SetBranchAddress("pydblhd",&pydblhd);
    tupep->SetBranchAddress("pzdblhd",&pzdblhd);
    tupep->SetBranchAddress("edbltkab",&edbltkab);
    tupep->SetBranchAddress("pxdbltkab",&pxdbltkab);
    tupep->SetBranchAddress("pydbltkab",&pydbltkab);
    tupep->SetBranchAddress("pzdbltkab",&pzdbltkab);
    tupep->SetBranchAddress("edbltkmpc",&edbltkmpc);
    tupep->SetBranchAddress("pxdbltkmpc",&pxdbltkmpc);
    tupep->SetBranchAddress("pydbltkmpc",&pydbltkmpc);
    tupep->SetBranchAddress("pzdbltkmpc",&pzdbltkmpc);
    tupep->SetBranchAddress("etkmpc",&etkmpc);
    tupep->SetBranchAddress("pxtkmpc",&pxtkmpc);
    tupep->SetBranchAddress("pytkmpc",&pytkmpc);
    tupep->SetBranchAddress("pztkmpc",&pztkmpc);

    tupep->GetEntry(ievt);	// get this event

    etot = etk + eem + ehd;
    ANL4DVector qtot(etot, pxtot, pytot, pztot); // after eliminating double counting.
    ANL4DVector qhd (ehd , pxhd , pyhd , pzhd ); // neutral hadrons

    if (TString(fname).Contains("hdexact")) {
      const Double_t kFcorr = 1.0;
    } else {
      const Double_t kFcorr = 1.065;
      //const Double_t kFcorr = 1.04;
      //const Double_t kFcorr = 1.0308;
    }
    ANL4DVector qhdc  = kFcorr * qhd;             // neutral hadrons after recalibration
    Double_t    ehdc  = qhdc.E();

    ANL4DVector qdbltk(edbltk, pxdbltk, pydbltk, pzdbltk);
    ANL4DVector qdblem(edblem, pxdblem, pydblem, pzdblem);
    ANL4DVector qdblhd(edblhd, pxdblhd, pydblhd, pzdblhd);
    ANL4DVector qdblhdc = kFcorr * qdblhd;       // double counted neutral hadrons after recalibration
#if 0
    ANL4DVector qtotc = qtot - qhd + qhdc;
    ANL4DVector qvisc   = qtotc + qdbltk + qdblem + qdblhdc;
#else
#if 0
    ANL4DVector qtotc = qtot - qhd + qhdc;
    //ANL4DVector qvisc   = qtotc + qdblem + qdblhdc;
    //ANL4DVector qvisc   = qtotc + qdbltk + qdblem;
    //ANL4DVector qvisc   = qtotc + qdbltk;
    ANL4DVector qdbltkab(edbltkab, pxdbltkab, pydbltkab, pzdbltkab);
    ANL4DVector qvisc   = qtotc + qdbltk - qdbltkab + qdblem + qdblhdc;
#else
    ANL4DVector qem      (eem , pxem , pyem , pzem ); // em PFOs
    ANL4DVector qtkmpc   (etkmpc, pxtkmpc, pytkmpc, pztkmpc); // tk PFOs with Mp corr.
    ANL4DVector qdbltkmpc(edbltkmpc, pxdbltkmpc, pydbltkmpc, pzdbltkmpc); // double counted tk with Mp corr.

    ANL4DVector qtotc  = qtkmpc + qem + qhdc;
    ANL4DVector qdbltkab(edbltkab, pxdbltkab, pydbltkab, pzdbltkab);
    ANL4DVector qvisc   = qtotc + qdbltkmpc - qdbltkab + qdblem + qdblhdc;
#endif
#endif

    ANL4DVector qah (eah, pxah, pyah, pzah);     // all undetected

    ANL4DVector qtotah = qtotc + qah; 

#if 0
    if (TMath::Abs(cosj1) < xCosj && TMath::Abs(cosj2) < xCosj) {
      hNpjp ->Fill(npj1       , 1.);
      hNpjp ->Fill(npj2       , 1.);
    }
    if (npj1 >= xNpj && npj2 >= xNpj) {
      hCosjp->Fill(cosj1      , 1.);
      hCosjp->Fill(cosj2      , 1.);
    }
    if (npj1 >= xNpj && npj2 >= xNpj &&
        TMath::Abs(cosj1) < xCosj && TMath::Abs(cosj2) < xCosj) {
      hEvisp->Fill(qvisc.E()   , 1.);
      hPtPlp->Fill(pt, pl      , 1.);
      hEtotp->Fill(qtotc.E()   , 1.);
      hMassp->Fill(qvisc.Mag() , 1.);
      hMjjcp  ->Fill(qtotc.Mag() , 1.);
      hMjjcahp->Fill(qtotah.Mag(), 1.);
    }
#else
      hNpjp ->Fill(npj1        , 1.);
      hNpjp ->Fill(npj2        , 1.);
      hCosjp->Fill(cosj1       , 1.);
      hCosjp->Fill(cosj2       , 1.);
      hEvisp->Fill(qvisc.E()   , 1.);
      hPtPlp->Fill(pt, pl      , 1.);
      hEtotp->Fill(qtotc.E()   , 1.);
      hMassp->Fill(qvisc.Mag() , 1.);
      hMjjcp  ->Fill(qtotc.Mag() , 1.);
      hMjjcahp->Fill(qtotah.Mag(), 1.);
#endif
  }
  // ------------------------------------------------------------
  //  Draw histograms
  // ------------------------------------------------------------
  gStyle->SetOptFit(1);

  gStyle->SetOptStat(111111);

  TCanvas *c1p = new TCanvas("c1","",20,20,1620,820);
  TCanvas &c1  = *c1p;
  c1.Divide(4,2);
  Int_t id = 0;

  TPad *cpadp;
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEvisp->Draw();
  ANLGaussFitter gfit(hEvisp,kNsig);
  gfit.GetFunction()->Draw("same");
  hEvisp->SetFillColor(50);
  hEvisp->SetFillStyle(1000);
  hEvisp->GetXaxis()->SetTitle("E_{vis} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hPtPlp->Draw();
  hPtPlp->SetFillColor(50);
  hPtPlp->SetFillStyle(3001);
  hPtPlp->GetXaxis()->SetTitle("P_{T} [GeV]");
  hPtPlp->GetYaxis()->SetTitle("P_{L} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hNpjp->Draw();
  hNpjp->SetFillColor(50);
  hNpjp->SetFillStyle(3001);
  hNpjp->GetXaxis()->SetTitle("N_{pfos/jet}");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hCosjp->SetMinimum(0.);
  hCosjp->Draw();
  hCosjp->SetFillColor(50);
  hCosjp->SetFillStyle(3000);
  hCosjp->GetXaxis()->SetTitle("cos(#theta_{jet})");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEtotp->Draw();
  ANLGaussFitter gfit(hEtotp,kNsig);
  gfit.GetFunction()->Draw("same");
  hEtotp->SetFillColor(50);
  hEtotp->SetFillStyle(1000);
  hEtotp->GetXaxis()->SetTitle("E_{tot} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hMassp->Draw();
  ANLGaussFitter gfit(hMassp,kNsig);
  gfit.GetFunction()->Draw("same");
  hMassp->SetFillColor(50);
  hMassp->SetFillStyle(1000);
  hMassp->GetXaxis()->SetTitle("M_{Z} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hMjjcp->Draw();
  ANLGaussFitter gfit(hMjjcp,kNsig);
  gfit.GetFunction()->Draw("same");
  hMjjcp->SetFillColor(50);
  hMjjcp->SetFillStyle(1000);
  hMjjcp->GetXaxis()->SetTitle("M_{jj} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hMjjcahp->Draw();
  ANLGaussFitter gfit(hMjjcahp,kNsig);
  gfit.GetFunction()->Draw("same");
  hMjjcahp->SetFillColor(50);
  hMjjcahp->SetFillStyle(1000);
  hMjjcahp->GetXaxis()->SetTitle("M_{jj+ah} [GeV]");

  c1.cd();
}
