//////////////////////////////////////////////////////////////////
//
//  Geant4 execution in JSF framework
//
//
//$Id: JSFJ4.cxx,v 1.42 2006/08/15 07:16:28 miyamoto Exp $
//
//////////////////////////////////////////////////////////////////
#include <iostream>

#include "JSFConfig.h"
#include "JSFSteer.h"
#include "JSFModule.h"
#include "JSFJ4.h"

ClassImp(JSFJ4)
ClassImp(JSFJ4Buf)
ClassImp(JSFJ4BufferMap)

//_____________________________________________________________________________
JSFJ4::JSFJ4(const char *name, const char *title)
  : JSFModule(name,title), fNcall(0), fNgood(0)
{

  fEventBuf=new JSFJ4Buf("JSFJ4Buf", "JSFJ4 event data", this);
}

//_____________________________________________________________________________
JSFJ4::~JSFJ4()
{
}

//_____________________________________________________________________________
Bool_t JSFJ4::Initialize()
{
  if( !IsWritable() ) { return kTRUE; }

  fNcall=0;
  fNgood=0;

  return kTRUE;
}

//_____________________________________________________________________________
Bool_t JSFJ4::Terminate()
{
  return kTRUE;
}

//_____________________________________________________________________________
Bool_t JSFJ4::BeginRun(Int_t irun)
{
  return kTRUE;
}

//_____________________________________________________________________________
Bool_t JSFJ4::EndRun()
{
  return kTRUE;
}



//_____________________________________________________________________________
Bool_t JSFJ4::Process(Int_t nev)
{
//
/*
  JSFJ4Outputs_t::iterator id;
  for( id=gJSFJ4Outputs.begin() ; id!=gJSFJ4Outputs.end(); id++ ) {
    ((*id).second)->Delete();  // Issue JSFJ4TOutput::Delete()
  }
  if (gBPOutputPtr) gBPOutputPtr->Delete();

  JSFJ4Buf *buf=(JSFJ4Buf*)EventBuf();

  Bool_t runstat=fRunManager->SimulateOneEvent(nev);
*/

  Bool_t runstat=kTRUE;

  if ( runstat ) {
    return kTRUE;
  }
  else {
    gJSF->SetReturnCode(JSFSteer::kJSFDoEndRun) ;
    return kTRUE;
  }
}

// ______________________________________________________________________________
JSFJ4Buf::JSFJ4Buf(const Char_t *name, const Char_t *title, JSFModule *module)
  : JSFEventBuf( name, title, module ),
    fEventID(0)
{
}

// ______________________________________________________________________________
JSFJ4Buf::JSFJ4Buf()
{
}

// ______________________________________________________________________________
JSFJ4Buf::~JSFJ4Buf()
{
  fEvent.Delete();

}

// ______________________________________________________________________________
TObjArray *JSFJ4Buf::AddComponent(Char_t *name)
{
  JSFJ4BufferMap *data=new JSFJ4BufferMap(name);
  fEvent.Add(data);

  return data->GetObjArray();
}

 
// ______________________________________________________________________________
TObjArray *JSFJ4Buf::GetComponent(Char_t *name) const
{
  for(Int_t i=0;i<fEvent.GetEntries();i++){
    JSFJ4BufferMap *m=(JSFJ4BufferMap*)fEvent.At(i);
    if( strcmp(name, m->GetName() ) == 0 ) {
      return m->GetObjArray();
    }
  }
  return 0;

}

// ______________________________________________________________________________
void JSFJ4Buf::Clear(const Char_t *name)
{
  // Delete event data in the buffer.
  // If name is not defined, delete all event dala
  std::cerr << "JSFJ4Buf::Clear is called name is " << name << std::endl;
  for(Int_t i=0;i<fEvent.GetEntries();i++){
    JSFJ4BufferMap *m=(JSFJ4BufferMap*)fEvent.At(i);
    std::cerr << " BufferMap ... " << m->GetName() << std::endl;
    if( strcmp(name,"") == 0 || strcmp(name, m->GetName() ) == 0 ) {
      m->GetObjArray()->Delete();
      std::cerr << " Deleted" << std::endl;
    }
  }
}

// ______________________________________________________________________________
void JSFJ4Buf::Print(Option_t *opt)
{
  std::cout << "List of JSFJ4 data" << std::endl;
  for(Int_t i=0;i<fEvent.GetEntries();i++){
    JSFJ4BufferMap *m=(JSFJ4BufferMap*)fEvent.At(i);
    std::cout << m->GetName() << std::endl;
  }
}

// --------------------------------------------------
JSFJ4BufferMap::JSFJ4BufferMap(Char_t *name)
  : fName(TString(name))
{
  fObjArray=new TObjArray();
}
// --------------------------------------------------
JSFJ4BufferMap::~JSFJ4BufferMap()
{
  fObjArray->Delete();
  delete fObjArray;
}

