#ifndef __S4FCALMCTRUTH__
#define __S4FCALMCTRUTH__
//*************************************************************************
//* ----------------
//* S4FCALMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4FCALMCTruth		: steering class
//* (Update Record)
//*	2006/02/01 A.Miyamot Original version.
//*************************************************************************

#include <fstream>
#include "S4VMCTruth.h"

using namespace std;

class S4FCALMCTruth : public S4VMCTruth {

public:
   S4FCALMCTruth(const Char_t *fname = "hit.dat", 
                const Char_t *name  = "S4FCALMCTruth",
                const Char_t *title = "Get FCAL ExactHit data");
	        
   virtual ~S4FCALMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t    *fInputFileName;            //!
   ifstream  *fInputStream;              //!

   ClassDef(S4FCALMCTruth, 1) // Read CAL ExactHit Data
};

#endif

