#ifndef __S4GENMCTRUTH__
#define __S4GENMCTRUTH__
//*************************************************************************
//* ------------------
//* S4GENMCTruth Class
//* ------------------
//* (Description)
//*     A class to book keep generator information.
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4GENMCTruth		: steering class
//* (Update Record)
//*	2005/04/01  K.Fujii	Original version.
//*************************************************************************

#include "S4VMCTruth.h"

class S4GENMCTruth : public S4VMCTruth {

public:
   S4GENMCTruth(const Char_t *fname = "hit.dat", 
                const Char_t *name  = "S4GENMCTruth",
                const Char_t *title = "Generator Information");
	        
   virtual ~S4GENMCTruth();

   Bool_t Initialize();
   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t        *fInputFileName;            //!
   std::ifstream *fInputStream;              //!

   ClassDef(S4GENMCTruth, 1) // Generator Information class
};

#endif

