#ifndef __S4HISTMCTRUTH__
#define __S4HISTMCTRUTH__
//*************************************************************************
//* -------------------
//* S4HISTMCTruth Class
//* -------------------
//* (Description)
//*     A class to book keep history information.
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4HISTMCTruth		: steering class
//* (Update Record)
//*	2006/02/03  K.Fujii	Original version.
//*************************************************************************

#include "S4VMCTruth.h"

class S4HISTMCTruth : public S4VMCTruth {
public:
   S4HISTMCTruth(const Char_t *fname = "hit.dat", 
                 const Char_t *name  = "S4HISTMCTruth",
                 const Char_t *title = "Generator Information");
	        
   virtual ~S4HISTMCTruth();

   Bool_t Initialize();
   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t        *fInputFileName;            //!
   std::ifstream *fInputStream;              //!

   ClassDef(S4HISTMCTruth, 1) // Generator Information class
};

#endif

