#ifndef __S4ITMCTRUTHBUF__
#define __S4ITMCTRUTHBUF__
//*************************************************************************
//* ----------------
//* S4VMCTruthBuf Class
//* ----------------
//* (Description)
//*	This set of classes reads ascii output of JUPITER and
//*	put them into root objects.
//* (Requires)
//*	S4VMCTruthBuf:
//* (Provides)
//*	S4VMCTruthBuf		: steering class
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	Original version.
//*************************************************************************

#include "S4ITMCTruth.h"
#include "S4VMCTruthBuf.h"
#include "S4ITTypeDef.h"
// ---------------
// MonteCarlo Truth Buffer
// ---------------

class S4ITMCTruthBuf : public S4VMCTruthBuf {

public:
  S4ITMCTruthBuf(const Char_t *name  = "S4ITMCTruthBuf",
                 const Char_t *title = "IT MCTruth Buf", 
                 S4ITMCTruth  *mod   =0,
                 Int_t         size  = 20000);

  S4ITMCTruthBuf(S4ITMCTruth   *mod,
                  const Char_t *name  = "S4ITMCTruthBuf",
		  const Char_t *title = "IT MCTruth Buf",
                  Int_t         size  = 20000);

  virtual   ~S4ITMCTruthBuf();

  TObjArray *GetInputBufPtr()                { return fInputBufPtr; }
  void       SetInputBufPtr(TObjArray *bufp) { fInputBufPtr = bufp; }
  void       MergeHits();

  Bool_t     ReadFile();

private:
  void       CleanUp(TObjArray &obp);       

private:
  TObjArray *fInputBufPtr;             //! 
  
  ClassDef(S4ITMCTruthBuf, 1) // IT raw data buffer
};

#endif

