#ifndef __S4MUDExactHit__
#define __S4MUDExactHit__

///////////////////////////////////////////////////////////////////////
//
//  JSFJ4 MUD Hit data
//
//$Id: S4MUDExactHit.h,v 1.1 2005/02/27 12:52:05 ono Exp $
//
///////////////////////////////////////////////////////////////////////

#include "S4VExactHit.h"
#include <TVector3.h>

class J4MUDHit;
class S4MUDPreHit;

// *******************************************************
class S4MUDExactHit : public S4VExactHit
{
 public:
  S4MUDExactHit();

  S4MUDExactHit(Int_t     hitID,       // hit ID
                Int_t     pcode,       // PDG code
          const TVector3  &pos,        // position [cm]
                Double_t  tof,         // TOF      [nsec]
                Double_t  edep,        // energy deposit [GeV]
                Int_t     preHitID,    // pre hit ID
                Int_t     blockID,     // blockID
                Int_t     layerID,     // layerID
                Int_t     isBarrel,    // barrel or Endcap 
                Int_t     isFront );   // Front or Not front endcap

  S4MUDExactHit(J4MUDHit *ahit);
  virtual ~S4MUDExactHit();

  // virtual functions in S4VExactHit
  static void SetSortBy(Char_t *opt="");
  virtual Int_t Compare(const TObject*) const;
  virtual Bool_t IsSortable();

  inline Int_t        GetPreHitID()    { return fPreHitID;     }
  inline Int_t        GetBlockID()     { return fBlockID;      }
  inline Int_t        GetLayerID()     { return fLayerID;      }
  inline Bool_t       IsBarrel()       { return fIsBarrel;     }
  inline Bool_t       IsFront()        { return fIsFront;      }

  inline S4MUDPreHit* GetPreHitPtr()   { return fPreHitPtr;    }
  inline void         SetPreHitPtr(S4MUDPreHit *p){fPreHitPtr = p; }
 
  virtual void Print(const Option_t *opt = "") const; //overrides TObject's

 private:
  Int_t        fPreHitID;         // PreHitID
  Int_t        fBlockID;          // CellID
  Int_t        fLayerID;          // layerID
  Bool_t       fIsBarrel;         // IsBarrel
  Bool_t       fIsFront;          // IsFront
  S4MUDPreHit *fPreHitPtr;        // pointer to pre hit 
  
  ClassDef(S4MUDExactHit, 2)  // S4MUDExactHit class

};

#endif
