#ifndef __S4CALTYPEDEF__
#define __S4CALTYPEDEF__

//*************************************************************************
//* ---------------------
//* S4CALTYPE 
//* ---------------------
//* (Description)
//*	
//* (Requires)
//*	
//* (Provides)
//*	S4CAL***		: TYPRDEF for CAL of metis
//* (Update Record)
//*	2004/09/04  S.Yamamoto	Original version.
//*************************************************************************
//---------------------
// definition
//---------------------

enum ECALType_t { kgNotDecided = 0x0000,   // Calorimeter Type not decided
                  kgBaEm       = 0x0001,   // Barrel EM
                  kgBaHd       = 0x0002,   // Barrel HD
                  kgEcEm       = 0x0004,   // Endcap EM
                  kgEcHd       = 0x0008 }; // Endcap HD       

enum EClusterType_t { kgNotDecided_cl             = 0x0000,   // not decided
                      kgEmCharged_cl              = 0x0002,   // EMcharged type
                      kgEmNeutral_cl              = 0x0004,   // EMneutral type
                      kgEmChargedPlusEmNeutral_cl = 0x0008,   // EMcharged+EMneutral type
                      kgHdCharged_cl              = 0x0010,   // HDcharged type
                      kgHdNeutral_cl              = 0x0020,   // HDneutral type
                      kgHdChargedPlusHdNeutral_cl = 0x0040,   // HDcharged+HDneutral type
		      kgCheated_cl                = 0x1000,   // Cheted version
		      kgCalBased_cl               = 0x2000,   // CalBased version
                      kgTrackBased_cl             = 0x4000 }; // TrackBased version

enum EParticleType_t { kgNotDecided_p         = 0x0000,       // not decided
                       kgElectron_p           = 0x0002,      // electron type
                       kgPhoton_p             = 0x0004,      // photon type
                       kgElectronPlusPhoton_p = 0x0008,      // electron+photon type
                       kgHdCharged_p          = 0x0010,      // HDcharged type
                       kgHdNeutral_p          = 0x0020,      // HDneutral type
                       kgHdmergeEm_p          = 0x0040,      // HD+EM type
		       kgMuon_p               = 0x0080 };    // muon type

// *** VERY TEMPORARY **** 
namespace PID { 
   enum EPID_t { kgNotDecided_id = 0,
                 kgElectron_id   = 1,
		 kgMuon_id       = 2,
                 kgPhoton_id     = 3,
                 kgPi_id         = 4,
                 kgK_id          = 5,
                 kgKL_id         = 6,
                 kgProton_id     = 7,
                 kgNeutron_id    = 8
               };

};

typedef PID::EPID_t EPID_t;
// *** END OF VERY TEMPORARY **** 

enum MatchedType_t { kgEMFitter        = 0,
		     kgEHCompare       = 1,
		     kgTrackMinLayer   = 2,
		     kgTrackTube       = 3,
		     kgTrackThrust     = 4,
		     kgILFinder        = 5,
		     kgEHMatcher       = 6,
		     kgEECompare       = 7,
		     kgTrackEC         = 8,
		     kgEMLateralSpread = 9,
		     kgEMLongitudinal  = 10,
		     kgHDFitter        = 11 };


#endif
