//*************************************************************************
//* --------------------
//* S4CALClusterMaker
//* --------------------
//* (Description)
//*	This set of classes makes CALClusters.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/02  S.Yamamoto	Original version.
//*************************************************************************

#include <iostream>
#include "JSFSteer.h"
#include "S4CALRealClusterMaker.h"
#include "S4CALRealClusterMakerBuf.h"
#include "S4CALSmallClusterMaker.h"
#include "S4CALSmallClusterMakerBuf.h"

#include <ctime>

//#define __ALLCHEAT__

ClassImp(S4CALRealClusterMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4CALRealClusterMaker::S4CALRealClusterMaker(const Char_t *name, const Char_t *title)
  : JSFModule(name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4CALRealClusterMaker::~S4CALRealClusterMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------

Bool_t S4CALRealClusterMaker::Initialize()
{
   std::cerr << " S4CALRealClusterMaker::Initialize is called " << std::endl;
   fEventBuf = new S4CALRealClusterMakerBuf(this);

   return kTRUE;
}

//=====================================================================
//* BeginRun ----------------------------------------------------------

Bool_t S4CALRealClusterMaker::BeginRun(Int_t /* run */ )
{
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4CALRealClusterMaker::Process(Int_t /* ev */ )
{

  clock_t start = clock();

  std::cout << "S4CALRealClusterMaker::Process() is called" << std::endl;

   S4CALSmallClusterMaker *sclmp = (S4CALSmallClusterMaker *)gJSF->FindModule("S4CALSmallClusterMaker");
   S4CALSmallClusterMakerBuf *sclmbufp = (S4CALSmallClusterMakerBuf *)sclmp->EventBuf();
   S4CALRealClusterMakerBuf *clmbufp;
   clmbufp = (S4CALRealClusterMakerBuf *)EventBuf();
   clmbufp->SetInputDataBufPtr(sclmbufp);
#ifdef __ALLCHEAT__
   clmbufp->MakeCheatedRealClusters();
#else
   clmbufp->MakeRealClusters();
#endif
   clock_t end = clock();
   std::cout << " S4CALRealCluster::Process() is finished..." << std::endl;
   std::cout << " spended time: " << (Float_t)(end-start)/CLOCKS_PER_SEC
             << " (sec)" << std::endl;

   return kTRUE;
}
