#ifndef __S4ITTRACK__
#define __S4ITTRACK__
//*************************************************************************
//* ---------------------
//* S4ITTrack Class
//* ---------------------
//* (Description)
//*	Class to store "S4ITHitCell"s for a single layer.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	S4ITTrack		: Array containing "S4ITHitCell"s
//* (Update Record)
//*	2004/09/06  A.Yamaguchi     Original version.
//*************************************************************************

#include "S4ITTrackMaker.h"
#include "U4ITTrack.h"
#include "S4VTrack.h"
#include "TAttDrawable.h"

class S4ITHit;

class S4ITTrack : public U4ITTrack, public S4VTrack, public TAttDrawable {
public:
  S4ITTrack();
  S4ITTrack(S4ITTrackMaker *trkm);
  virtual ~S4ITTrack();

  virtual void   DebugPrint(const Char_t *opt = "Brief");
  using TAttDrawable::Draw;
  virtual void   Draw(Int_t color, const Char_t *opt = "");

  virtual Int_t  GetPDGCode();
  virtual Int_t  GetTrackID();
  virtual Int_t  GetMotherTrackID();

  virtual Bool_t Verify();

private:

  ClassDef(S4ITTrack, 1)		   // IT Track
};

#endif
