#ifndef __S4ITTRACKHIT__
#define __S4ITTRACKHIT__
//*************************************************************************
//* ---------------------
//* S4ITTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single track hit.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	S4ITTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "S4ITHit.h"
#include "U4ITTrackHit.h"


class S4ITTrackHit : public U4ITTrackHit {
friend class S4ITTrack;
public:
  S4ITTrackHit();
  S4ITTrackHit(S4ITHit *ht);
  S4ITTrackHit(const S4ITTrackHit &hit);
  virtual ~S4ITTrackHit();

  static   void   SetSortBy(Char_t *opt = "Time");
  virtual  Int_t  Compare(const TObject *obj) const;

  inline virtual S4ITHit *GetHitPtr  () {
     return  dynamic_cast<S4ITHit *> (U4VTrackHit::GetHitPtr());
  }
       
private:

  ClassDef(S4ITTrackHit, 1)       // IT Hit 
};


#endif
