//*************************************************************************
//* --------------------
//* S4TPCTrackMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/06  A.Yamaguchi    Original version.
//*************************************************************************

#include "S4TPCTrackMaker.h"
#include "S4TPCTrackMakerBuf.h"
#include <iostream>

ClassImp(S4TPCTrackMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4TPCTrackMaker::S4TPCTrackMaker(const Char_t *name, const Char_t *title)
               : U4TPCTrackMaker(name,title)
{
}

S4TPCTrackMaker::S4TPCTrackMaker(U4TPCKalDetector *det,
                                 const Char_t     *name,
                                 const Char_t     *title)
               : U4TPCTrackMaker(det, name, title)
{
#ifdef __DEBUG__
   std::cerr << " constructor for S4TPCTrackMaker is called..." << std::endl;
#endif
}

//=====================================================================
//* destructor --------------------------------------------------------

S4TPCTrackMaker::~S4TPCTrackMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4TPCTrackMaker::Initialize()
{
   fEventBuf = new S4TPCTrackMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* BeginRun() ------------------------------------------------------

Bool_t S4TPCTrackMaker::BeginRun(Int_t /* run */)
{
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------
                                                                                 
Bool_t S4TPCTrackMaker::Process(Int_t  /* ev */)
{
   S4TPCTrackMakerBuf *tmbufp = dynamic_cast<S4TPCTrackMakerBuf *>(EventBuf());
   tmbufp->SetInputDataBufPtr(gJSF->FindModule("S4TPCHitMaker")->EventBuf());
   tmbufp->MakeTracks();

   return kTRUE;
}

