#ifndef __S4TPCTRACKMAKERBUF__
#define __S4TPCTRACKMAKERBUF__
//*************************************************************************
//* ---------------------
//* S4TPCTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4TPCTrackMakerBuf		: buffering class
//* (Update Record)
//*	2004/08/26  A.Yamaguchi	    Original version.
//*************************************************************************

//#include "JSFSteer.h"
#include "U4TPCTrackMakerBuf.h"
#include "S4TPCTrackMaker.h"
#include "S4TPCHitMakerBuf.h"

class S4TPCTrack;

class S4TPCTrackMakerBuf : public U4TPCTrackMakerBuf {
friend class S4TPCTrackMaker;

public:

  S4TPCTrackMakerBuf(const Char_t *name  = "S4TPCTrackMakerBuf",
                     const Char_t *title = "TPC Track data",
		     S4TPCTrackMaker *module=0, Int_t bufsize = 2000);
  S4TPCTrackMakerBuf(S4TPCTrackMaker *module,
                     const Char_t *name  = "S4TPCTrackMakerBuf",
                     const Char_t *title = "TPC Track data",
                     Int_t bufsize = 2000);
		    
  virtual ~S4TPCTrackMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "Brief") {}

private:  
  virtual void	MakeTracks();                            // Make TPC Tracks

  ClassDef(S4TPCTrackMakerBuf, 1) // Cluster data buffer
};

#endif
