#ifndef __S4VTXTRACK__
#define __S4VTXTRACK__
//*************************************************************************
//* ---------------------
//* S4VTXTrack Class
//* ---------------------
//* (Description)
//*	Class to store "S4VTXHitCell"s for a single layer.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	S4VTXTrack		: Array containing "S4VTXHitCell"s
//* (Update Record)
//*	2004/09/06  A.Yamaguchi     Original version.
//*************************************************************************

#include "S4VTXTrackMaker.h"
#include "U4VTXTrack.h"
#include "S4VTrack.h"
#include "TAttDrawable.h"

class S4VTXHit;

class S4VTXTrack : public U4VTXTrack, public S4VTrack, public TAttDrawable {
public:
  S4VTXTrack();
  S4VTXTrack(S4VTXTrackMaker *trkm);
  virtual ~S4VTXTrack();

  virtual void   DebugPrint(const Char_t *opt = "Brief") { }
  using TAttDrawable::Draw;
  virtual void   Draw(Int_t color, const Char_t *opt = "");

  virtual Int_t  GetPDGCode();
  virtual Int_t  GetTrackID();
  virtual Int_t  GetMotherTrackID();

  virtual Bool_t Verify();

 private:

  ClassDef(S4VTXTrack, 1)		   // VTX Track

};

#endif
