//*************************************************************************
//* ---------------------
//* S4VTXTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	S4VTXTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "S4VTXTrackHit.h"

ClassImp(S4VTXTrackHit)


//=====================================================================
//* constructor -------------------------------------------------------

S4VTXTrackHit::S4VTXTrackHit()
{
}

S4VTXTrackHit::S4VTXTrackHit(S4VTXHit *ht)
             : U4VTXTrackHit(ht)
{
}

S4VTXTrackHit::S4VTXTrackHit(const S4VTXTrackHit &ht)
             : U4VTXTrackHit(ht)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4VTXTrackHit::~S4VTXTrackHit()
{
}

//=====================================================================
//* SetSortBy() -------------------------------------------------------

void S4VTXTrackHit::SetSortBy(Char_t *opt )
{
   switch (opt[2]) {
      case 'm':       // sort by "Time"
      default:
         U4VTrackHit::SetSortBy(0);
         break;
   }
}

//=====================================================================
//* Compare() ---------------------------------------------------------

Int_t S4VTXTrackHit::Compare(const TObject *obj) const
{
   switch (GetSortBy()) {
      case 0: 
      default: {
         Double_t tof  = const_cast<S4VTXTrackHit *>(this)
                              ->GetHitPtr()->GetExactHitPtr()->GetTOF();
         Double_t tofo = ((S4VTXTrackHit *)obj)
                              ->GetHitPtr()->GetExactHitPtr()->GetTOF();
         return (tof < tofo ? -1 : (tof > tofo ? 1 : 0));
         break;
      }
   }
}

