//*************************************************************************
//* --------------------
//* S4VTXTrackMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/06  A.Yamaguchi    Original version.
//*************************************************************************

#include "S4VTXTrackMaker.h"
#include "S4VTXTrackMakerBuf.h"
#include <iostream>
//#define __DEBUG__

ClassImp(S4VTXTrackMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4VTXTrackMaker::S4VTXTrackMaker(const Char_t *name, const Char_t *title)
               : U4VTXTrackMaker(name,title)
{
}

S4VTXTrackMaker::S4VTXTrackMaker(U4VTXKalDetector *det,
                                 const Char_t     *name,
                                 const Char_t     *title)
               : U4VTXTrackMaker(det, name, title)
{
#ifdef __DEBUG__
   std::cerr << " constructor for S4VTXTrackMaker is called..." << std::endl;
#endif
}

//=====================================================================
//* destructor --------------------------------------------------------

S4VTXTrackMaker::~S4VTXTrackMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4VTXTrackMaker::Initialize()
{
#ifdef __DEBUG__
   std::cerr <<" S4VTXTrackMaker Initialize called" << std::endl;
#endif
   fEventBuf = new S4VTXTrackMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------
                                                                                 
Bool_t S4VTXTrackMaker::Process(Int_t  /* ev */)
{
   S4VTXTrackMakerBuf *tmbufp = static_cast<S4VTXTrackMakerBuf *>(EventBuf());
   tmbufp->SetInputDataBufPtr(gJSF->FindModule("S4VTXHitMaker")->EventBuf());

   return kTRUE;

}

