#ifndef __USERANALYSIS__
#define __USERANALYSIS__

#include "VUserAnalysis.h"
#include "TStyle.h"
#include "TH1.h"
#include "TH2.h"
#include "TGraph.h"
#include "TMath.h"
#include "U4BabyTrackMaker.h"
#include "U4BabyTrack.h"
#include "U4CDCHit.h"
#include "TPaveLabel.h"

#include "HardwareMapParam.dat"

class UserAnalysis : public VUserAnalysis {
public:
	UserAnalysis(BabyDisplay *display, U4CDCFADCCalibration *calib);
	virtual ~UserAnalysis();

	void InitRawFADC();
	void DrawRawFADC();
	void InitCounters();
	void DrawCounters();
	void UpdateCounterInfo();
	
	void Initialize();
	void DrawHist();

private:
        TPaveLabel   fLabel;		//!
        TH1F        **hHADC;    	//!
        TH1F        *hHod1;             //!
        TH1F        *hHod2;             //!
        TH2F        *hHod12;            //!
        TH2F        *hHodADC12;         //!
        TH2F        *hHod12lo;          //!
        TH2F        *hHod12hi;          //!
        TH2F        *hTC1TC2;           //!
        TH2F        *hMonHod;           //!
        TH2F        *hHod1hs;           //!
        TH2F        *hNHod12;           //!
        TH2F        *hMonCsi;           //!
	TH1F       **hFADC;		//!
	
	ClassDef(UserAnalysis, 1)   // A class to analyze event
};

#endif
