#ifndef __U4CDCHITMAKER__
#define __U4CDCHITMAKER__

//*************************************************************************
//* ---------------------
//* U4CDCHitMaker Class
//* ---------------------
//* (Description)
//*	This set of classes makes Smearing Hits.
//* (Requires)
//*	JSFModules:
//* (Provides)
//*	U4CDCHitMaker		: steering class
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*************************************************************************

#include "U4VHitMaker.h"
#include "U4CDCTimeToXRelation.h"
#include "U4CDCClusterMaker.h"
#include "U4CDCClusterBuf.h"

class U4CDCTimeToXRelation;
class U4CDCHitMaker : public U4VHitMaker {
public:
  U4CDCHitMaker(U4CDCTimeToXRelation *calib = 0,
  		 const Char_t *name="U4CDCHitMaker",
		 const Char_t *title="CDC Hit Maker");
		 
  virtual ~U4CDCHitMaker();

  void 		SetCalibrationData(U4CDCTimeToXRelation *calib);
  U4CDCTimeToXRelation *GetCalibPtr() const { return fCalibPtr; }

  virtual Bool_t Initialize();		// job initialization
  virtual Bool_t BeginRun(Int_t run);	// process Begin Run record
  virtual Bool_t Process(Int_t  ev) ;	// process event
  
private:
  Bool_t	        fToDeleteCalib;	// delete Calib in dtor or not
  U4CDCTimeToXRelation *fCalibPtr;	//!pointer to Hit calibration data

  ClassDef(U4CDCHitMaker, 1) 	// CDC hit maker
};

#endif
