#ifndef __U4CDCRAWHIST__
#define __U4CDCRAWHIST__

//*************************************************************************
//* ----------
//* U4CDCRawHist
//* ----------
//* (Description)
//* 	Classes for U4CDC raw data analysis.
//* (Update Record)
//*	1999/06/05  K.Fujii	Original version.
//*************************************************************************

#include "TObject.h"
#include "TH1.h"
#include "TCanvas.h"

#include "U4CDCRawData.h"

class U4CDCRawHist : public JSFModule {
public:
   struct THdef1 {
      Char_t   title[256];
      Int_t    nbin;
      Float_t  xmin;
      Float_t  xmax;
   };
   TCanvas  *hcp;		//! Canvas to draw Ph histograms
   TH1F    **hPh;		//! U4CDC pulse height histograms
   THdef1   *hdefp;		//! histogram parameters for Ph
   TCanvas  *hct;		//! Canvas to draw Ts histograms
   TH1F    **hTs;		//! U4CDC start time histograms
   THdef1   *hdeft;		//! histogram parameters for Ts
   static const Int_t kNh;	//! # hists
   static const Int_t kZoneX;	//! # X divisions
   static const Int_t kZoneY;	//! # Y divisions
public:
   U4CDCRawHist(const Char_t *name="U4CDCRawHist",
	      const Char_t *title="U4CDC Raw Data Histograms");
   virtual ~U4CDCRawHist();

   Bool_t Initialize();
   Bool_t Process(Int_t ev);
   
   void Draw(Option_t *opt="");

   ClassDef(U4CDCRawHist, 1) // Histograms of U4CDC Raw data
};

#endif
