#ifndef __U4HYBTRACKMAKER__
#define __U4HYBTRACKMAKER__

//*************************************************************************
//* ---------------------
//* U4HYBTrackMaker Class
//* ---------------------
//* (Description)
//*    Makes hybrid tracks.
//* (Requires)
//*	U4VTrackMaker
//* (Provides)
//*	U4HYBTrackMaker		: steering class
//* (Update Record)
//*	2004/09/07  K.Fujii 	Original version.
//*************************************************************************

#include "U4VTrackMaker.h"

class U4KalDetector;

class U4HYBTrackMaker : public U4VTrackMaker {
public:
  U4HYBTrackMaker(U4KalDetector *detp  = 0,
                  const Char_t  *name  = "U4HYBTrackMaker",
		  const Char_t  *title = "Hybrid Track Maker");
#if 0
  //
  // Eventually this module should put all the component KalDetector
  // objects into a single KalDetector (U4HYBKalDetector) and do
  // Kalman filter.
  //
  U4HYBTrackMaker(U4HYBKalDetector *det, 
                  const Char_t *name ="U4HYBTrackMaker",
		  const Char_t *title="Hybrid Track Maker");
#endif
		 
  virtual ~U4HYBTrackMaker();

  virtual Bool_t Initialize();          // job initialization
  virtual Bool_t BeginRun  (Int_t run); // process Begin Run record
  virtual Bool_t Process   (Int_t  ev); // process event

  virtual void   SetMainTrackMakerPtr(U4VTrackMaker *trkmp); 
  virtual void   AddSubTrackMakerPtr (U4VTrackMaker *trkmp); 

private:

  ClassDef(U4HYBTrackMaker, 1) 	// Baby track maker
};

#endif
