#ifndef __U4HYBTRACKMAKERBUF__
#define __U4HYBTRACKMAKERBUF__

//*************************************************************************
//* ---------------------
//* U4HYBTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4HYBTrackMakerBuf		: buffering class
//* (Update Record)
//*	1999/12/04  R.Kuboshima	    Original version.
//*************************************************************************

#include "JSFSteer.h"
#include "U4VTrackMakerBuf.h"
#include "U4HYBTrackMaker.h"
#include "U4HYBTrack.h"


class U4HYBTrackMakerBuf : public U4VTrackMakerBuf {
friend class U4HYBTrackMaker;

public:

  U4HYBTrackMakerBuf(const Char_t          *name    = "U4HYBTrackMakerBuf",
                     const Char_t          *title   = "HYB Track data",
		           U4HYBTrackMaker *module  = 0,
                           Int_t            bufsize = 2000);
  U4HYBTrackMakerBuf(      U4HYBTrackMaker *module,
                     const Char_t          *name    = "U4HYBTrackMakerBuf",
                     const Char_t          *title   = "HYB Track data",
                           Int_t            bufsize = 2000);
		    
  virtual ~U4HYBTrackMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "Brief");

  inline void AddInputSubTracker(JSFEventBuf *tp) { fInputSubTracker.Add(tp); }
  inline TObjArray *GetInputSubTrackerPtr() { return &fInputSubTracker; }

  inline virtual U4HYBTrack *CreateHYBTrack() { return new U4HYBTrack(); }
protected:  
  virtual void	MakeTracks() ;	// Make Tracks
  
private:  
  TObjArray    fInputSubTracker;

  ClassDef(U4HYBTrackMakerBuf, 1) // Cluster data buffer
};

#endif
