//*************************************************************************
//* ---------------------
//* U4ITTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single Baby hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	U4ITTrackHit		: 
//* (Update Record)
//*	2004/08/24  A.Yamaguchi
//*************************************************************************

#include "U4ITTrackHit.h"
#include "U4ITHit.h"

ClassImp(U4ITTrackHit)

//=====================================================================
//* constructor -------------------------------------------------------

U4ITTrackHit::U4ITTrackHit()
{
}

U4ITTrackHit::U4ITTrackHit(U4ITHit *htp)
            : U4VTrackHit(htp)
{
}
	
U4ITTrackHit::U4ITTrackHit(const U4ITTrackHit &hit)
            : U4VTrackHit(hit) 
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4ITTrackHit::~U4ITTrackHit()
{
}

//=====================================================================
//* SetSortBy --------------------------------------------------------
                                                                                
void U4ITTrackHit::SetSortBy(Char_t *opt )
{
   switch (opt[2]) {
         case 'y':       // sort by "LayerID"
         default:
            U4VTrackHit::SetSortBy(0);
            break;
   }
}
                                                                                
//=====================================================================
//* Compare -----------------------------------------------------------
Int_t U4ITTrackHit::Compare(const TObject *obj) const
{
   switch (GetSortBy()) {
      case 0:
      default: {
         Int_t layerID   = const_cast<U4ITTrackHit *>(this)
                                        ->GetHitPtr()->GetLayerID();
         Int_t layerIDo  = ((U4ITTrackHit *)obj)
                                        ->GetHitPtr()->GetLayerID();
         return (layerID < layerIDo ? -1 : (layerID > layerIDo ? 1 : 0));
      }
   }
}
