#ifndef __U4VANALYSIS__
#define __U4VANALYSIS__

//*************************************************************************
//* ------------
//* U4VAnalysis
//* ------------
//* (Description)
//* 	Base class to analyze CDC data.
//* (Update Record)
//*	2001/11/19  K.Fujii	Original version.
//*************************************************************************

#include "TObject.h"
#include "TH2.h"
#include "TH1E.h"
#include "TCanvas.h"

#include "U4VTrackMaker.h"



class U4VAnalysis : public JSFModule {
public:
   U4VAnalysis(const Char_t *name="U4VAnalysis",
		  const Char_t *title="CDC Analysis");
   virtual ~U4VAnalysis();

   virtual Bool_t Initialize();
   virtual Bool_t Process(Int_t ev);
   virtual void Draw(Option_t *option="") = 0;

protected:
   struct THdef1 {
      Char_t   title[256];
      Int_t    nxbin;
      Float_t  xmin;
      Float_t  xmax;
   };
   struct THdef2 {
      Char_t   title[256];
      Int_t    nxbin;
      Float_t  xmin;
      Float_t  xmax;
      Int_t    nybin;
      Float_t  ymin;
      Float_t  ymax;
   };

   ClassDef(U4VAnalysis, 1) // CDC Analysis class
};

#endif





